specification:		{ phylumdeclaration | rwdeclaration | functiondeclaration |
			  includedeclaration | unparsedeclaration | viewdeclaration | storageclassdeclaration } ;

phylumdeclaration:	ID [storage_option] ':' [productionblock] [Ccode] ';' ;

storage_option:		'{' ['!'] ID '}' ;

productionblock:	'list' ID | alternative_list ;

alternative_list:	[alternative_list '|'] ID '(' arguments ')' ;

arguments:		{ID} ; 

Ccode:			'{' [Attributes] [Cbody] '}' ;

Attributes:		[Attributes] ID ID ['=' Cexpression] ';' ;

Cexpression:		/* arbitrary C expression without ';' with '$0' */

includedeclaration:	'%{' {ID} includes '%}' ; /* the tokens are at the beginning of a line */
			/* ID's in {ID} are at the same line as '%{' */

includes:		/* arbitrary text */ ;

rwdeclaration:		outmostpatterns '->' outmostterm ';' ;

outmostpatterns:	outmostpattern | outmostpattern ',' outmostpatterns ;

outmostpattern:		[ID '='] ID ['(' [patterns] ')'] ;

patterns:		pattern | pattern ',' patterns ;

pattern:		ID '=' pattern
|			ID ['(' [patterns] ')']
|			'"' /* any string of characters */ '"'
|			/* a number */
|			'*' | 'default'
;

outmostterm:		ID '(' [terms] ')' ;

term:			ID ['(' [terms] ')'] 
|			'"' /* any string of characters */ '"'
|			/* a number */
;

terms:			term | term ',' terms ;

functiondeclaration:	['static'] Ctype ID '(' [fnarguments] ')' {fnargdecl} MainCbody ;

fnarguments:		[fnarguments ','] ['$'] ID ;
/* only one of the arguments can have a $ prefix */

fnargdecl:		Ctype ID ';' 
|			Ctype '(*' ID ')();'
;

Ctype:			ID {'*'} ;

MainCbody:		Cbody | with_clause ; /* a with_clause if one the fnarguments has a $ prefix */

Cbody:			'{' Ctext '}' ;

Ctext:			/* arbitrary C text, with $0 through $n, 
			   with_statement and foreach_statement */ ;

foreach_statement:	'foreach' '(' ID ';' ID Cexpression ')' Cbody
|			'foreach' '(' '$' ID ';' ID Cexpression ')' with_clause
|			'foreach' '(' outmostpattern ';' ID Cexpression ')' Cbody
;

with_statement:		'with' '(' Cexpression ')' with_clause ;

with_clause:		'{' {outmostpatterns ':' Cbody} ['default :' Cbody] '}' ;

/* with clauses should not have an empty list of patterns */

unparsedeclaration:	outmostpatterns '->' {unparseclause} ';' ;

unparseclause:		'[' viewnames ':' {unparseitem} ']' ;

viewnames:		{ID} ;

unparseitem:		'"' /* any string of characters*/ '"'  [':' ID]
|			['(' ID ')']  ID  {'->' ID}  [':' ID]
|			Cbody
|			'${' {unparseitem} '$}'
;

viewdeclaration:	'%view' viewnames ';' ;

storageclassdeclaration:	'%storageclass' {ID} ';' ;
